namespace org.accordproject.finance.loan;
using org.accordproject.time;
using org.accordproject.money;
using AccordProject.Concerto;
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum CurrencyType {
      MONETARY,
      CRYPTOMONETARY,
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.finance.loan", Version = "0.2.0", Name = "PaymentFrequency")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class PaymentFrequency : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.finance.loan@0.2.0.PaymentFrequency";
   public int periodMultiplier { get; set; }
   public Duration period { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.finance.loan", Version = "0.2.0", Name = "Loan")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Loan : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.finance.loan@0.2.0.Loan";
   public string[] instrumentId { get; set; }
   public string description { get; set; }
   public CurrencyType currencyType { get; set; }
   public CurrencyCode? currencyCode { get; set; }
   public DigitalCurrencyCode? DigitalCurrencyCode { get; set; }
   public string[] exchangeId { get; set; }
   public string clearanceSystem { get; set; }
   public string definition { get; set; }
   public string lien { get; set; }
   public string facilityType { get; set; }
   public System.DateTime maturity { get; set; }
   public System.DateTime creditAgreementDate { get; set; }
   public string tranche { get; set; }
}
